%=======================================================================|
%American Optimal Decisions, Inc. Copyright                             |
%Copyright American Optimal Decisions, Inc. 2007-2014.                 |
%American Optimal Decisions (AOD) retains copyrights to this material.  |
%                                                                       |
%Permission to reproduce this document and to prepare derivative works  |
%from this document for internal use is granted, provided the copyright |
%and No Warranty  statements are included with all reproductions       |
%and derivative works.                                                  |
%                                                                       |
%For information regarding external or commercial use of copyrighted    |
%materials owned by AOD, contact AOD at support@aorda.com.              |
%=======================================================================|

% This function prepares matrix of scenarios and matrix for budget constraint 
% for optimization in program CS_CDO_Hedging_MAD.m 

function [matrix_scenarios,matrix_budget]=Data_preparation(Pi,BOCds,BOInd,DurCds,DurInd,HistCdsSpread,HistIndSpread);
n=size(Pi,1);
m=size(HistCdsSpread,2);
k=size(HistIndSpread,1);

% Calculate change in CDS spread
for i=1:m-1
for j=1:n
DeltaSpCds(j,i)=HistCdsSpread(j,i+1)-HistCdsSpread(j,i);
end
end

% Calculate change in index spread 
for i=1:m-1
for j=1:k
DeltaSpInd(j,i)=HistIndSpread(j,i+1)-HistIndSpread(j,i);
end
end

% Calculate components of matrix of scenarios
for i=1:m-1
for j=1:n
DeltaPi(j,i)=Pi(j).*DeltaSpCds(j,i);
end
end
benchmark=-(DeltaPi);
for i=1:m-1
for j=1:n
DeltaCds(j,i)=DurCds(j).*DeltaSpCds(j,i);
end
end
for i=1:m-1
for j=1:k
DeltaInd(j,i)=DurInd(j).*DeltaSpInd(j,i);
end
end
benchmark=benchmark';
sum_bench=sum(benchmark,2);

% Calculate components of budget matrix
BOD_Cds=(BOCds.*DurCds)';
BOD_Ind=(BOInd.*DurInd)';
BOD_Cds=0.5*(BOCds.*DurCds)';
BOD_Ind=0.5*(BOInd.*DurInd)';
DeltaCds=DeltaCds';
DeltaInd=DeltaInd';
z=[1:50]';

% Calculate probabilities of scenarios
scen_prob(1:m-1,1)=1/m;

% Generate matrix of scenarios
matrix_scenarios=[z DeltaCds DeltaInd scen_prob sum_bench];

%Generate budget matrix
matrix_budget=[1 BOD_Cds BOD_Ind 1 0];